
from typing import Any, Callable



class MQTTProperty:

  def __init__(self, name: str = None, initialValue: Any = None, getConvert: Callable[[str], Any] = None, setConvert: Callable[[Any], str] = None, readOnly = False):

    self.__ro = readOnly
    self.__value = initialValue

    if getConvert is not None:
      self.__name = getConvert.__name__
      self.__getConvert = getConvert
    else:
      self.__getConvert = lambda x: x

    if setConvert is not None:
      self.__setConvert = setConvert
    else:
      self.__setConvert = lambda x: x



  def __call__(self, getConvert: Callable[[str], Any]):
    self.__getConvert = getConvert

  def __get__(self, obj, cls):
    pass

  def __set__(self, obj, value):
    if self.__ro: raise AttributeError(f'MQTTProperty[ {self.__name} ] is read-only')
    pass

  def __del__(*ignored):
    raise AttributeError('deletion not supported')



class Device:

  def __init__(self, torch, name, online = True):
    self._torch = torch
    self._name = name
    self.__online = online

  @property
  def name(self):
    return self._name

  @property
  def online(self):
    return self.__online


class Extension:

  def __init__(self, device: Device):
    setattr(device, type(self).__name__, self)


class ExtensionManager:

  def __init__(self):
    pass

